
    title   GeneSys SendMail Utility, v1.3.0
; ___________________________________________________
;|                                                   |
;| GeneSys SendMail Utility, v1.3.0        Sami Paju |
;| sami@paju.nu     http://x86assembly.codegurus.org |
;|___________________________________________________|
;|                                                   |
;| The Version Key Usage:   GeneSys SendMail a.b.c   |
;|           a:  a major change to the GUI           |
;|           b:  functions added and/or changed      |
;|           c:  bug fixes                           |
;|                                                   |
;| Version History:                                  |
;|                                                   |
;| 18Jul2006  v1.3.0  Cleaned up the code. I removed |
;|                    some testing stuff.  Fisished  |
;|                    translating the comments       |
;|                                                   |
;| 07Jul2006  v1.2.0  Repaired the errors in the     |
;|                    messaging system so it gives   |
;|                    meaningful reports when the    |
;|                    odd problem is found.          |
;|                                                   |
;! 05Jul2006  v1.1.0  The first successful live test |
;|                    was performed on this date.    |
;|                                                   |
;| 01Jul2006  v1.0.0  Initial release.               |
;|                                                   |
;| This nice little utility, SendMail.exe has been   |
;| designed to be used as a simple replacement for a |
;| standard email program. Its purpose is to provide |
;| a way to quickly send a short message without any |
;| attachments.                                      |
;|                                  Paul E. Brennick |
;|___________________________________________________|
;|                                                   |
        .486      ; Maintain downwards compatibility |
        .model  flat, stdcall  ; 32 bit memory model |
        option  casemap:none   ; Case Sensitive == 1 |
;|___________________________________________________|

    include \GeneSys\include\windows.inc
    include \GeneSys\include\kernel32.inc
    include \GeneSys\include\user32.inc
    include \GeneSys\include\gdi32.inc
    include \GeneSys\include\advapi32.inc
    include \GeneSys\include\GeneSys.inc
    include \GeneSys\include\comctl32.inc
    include \GeneSys\include\comdlg32.inc
    include \GeneSys\include\shell32.inc
    include \GeneSys\include\wsock32.inc

    includelib  \GeneSys\lib\kernel32.lib
    includelib  \GeneSys\lib\user32.lib
    includelib  \GeneSys\lib\gdi32.lib
    includelib  \GeneSys\lib\advapi32.lib
    includelib  \GeneSys\lib\GeneSys.lib
    includelib  \GeneSys\lib\comctl32.lib
    includelib  \GeneSys\lib\comdlg32.lib
    includelib  \GeneSys\lib\shell32.lib
    includelib  \GeneSys\lib\wsock32.lib

    AppPath             PROTO :DWORD
    BuildString         PROTO :DWORD, :DWORD
    Convert             PROTO :DWORD
    DlgProc             PROTO :DWORD, :DWORD, :DWORD, :DWORD
    GetLength           PROTO :DWORD
    GetSettingsFromIni  PROTO
    HandleError         PROTO
    InStringx           PROTO :DWORD, :DWORD
    ProcessCommand      PROTO :DWORD, :DWORD
    RConnect            PROTO :DWORD
    ReplyMessage        PROTO :DWORD
    RReadSocket         PROTO :DWORD
    SendMail            PROTO :DWORD
    WinMain             PROTO
    WSAHandleError      PROTO

    CTEXT MACRO text:VARARG
      LOCAL TxtName
      .data
        TxtName BYTE text, 0
      .code
      EXITM <ADDR TxtName>
    ENDM

.const
;====================
    MsgCopyright    db  "SendMail v1.3.0 - (c) 2003 Sami Paju", 0
    IDI_ICON1       equ 100
    IDC_EDTSERVER   equ 1000
    IDC_BTNSEND     equ 1001
    IDC_EDTPORT     equ 1002
    IDC_EDTNAME     equ 1003
    IDC_CHKAUTORUN  equ 1004
    IDC_EDTFROM     equ 1004
    IDC_EDTTO       equ 1005
    IDC_EDTSUBJECT  equ 1006
    IDC_EDTMESSAGE  equ 1007
    IDC_CHARS       equ 1008
    IDC_BTNHIDE     equ 1009
    IDC_BTNCLEAR    equ 1010
    IDM_RESTORE     equ 2000
    IDM_QUIT        equ 2001
    WM_SHELLNOTIFY  equ WM_USER + 5
    IDI_TRAY        equ 0
    MAX_SERVERNAME  equ 200
    MAX_PORT        equ 5
    MAX_DISPLAYNAME equ 200
    MAX_FROMADDRESS equ 200
    MAX_TOADDRESS   equ 200
    MAX_SUBJECT     equ 200
    MAX_MESSAGE     equ 30000
    WM_SOCKET       equ WM_USER + 100

.data
;====================
    State               dd  0
    DlgName             db  "MAIN", 0
    DlgTitleText        db  "SendMail v1.3.0", 0
    szIniFileName       db  "SendMail.ini", 0
    szIniSectionName    db  "Settings", 0

.data?
;====================
    hInstance           dd  ?
    sock                dd  ?
    hMemory             dd  ?
    buffer              dd  ?
    available_data      dd  ?
    actual_data_read    dd  ?
    EditBackgroundBrush dd  ?
    hPopupMenu          dd  ?
    nSMTPServerPort     dd  ?
    SMTPServerPort      db  6 dup(?)
    SMTPServerName      db  220 dup(?)
    FriendlyName        db  220 dup(?)
    FromAddress         db  220 dup(?)
    ToAddress           db  220 dup(?)
    MailSubject         db  220 dup(?)
    MailMessage         db  31000 dup(?)
    TrayIcon            NOTIFYICONDATA  <>
    wsadata             WSADATA         <>
    sin                 sockaddr_in     <>

.code
;====================
Start:
    invoke  GetModuleHandle, NULL
    mov     hInstance, eax
    invoke  WinMain
    invoke  ExitProcess, eax
    invoke  InitCommonControls

WinMain proc
;====================
    invoke  GetSettingsFromIni
    mov     eax, OFFSET DlgProc
    invoke  DialogBoxParam, hInstance, ADDR DlgName, NULL, eax, NULL
    xor     eax, eax
    ret
;====================
WinMain endp

DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;====================
    LOCAL   pt          :POINT
    LOCAL   nLineCount  :DWORD
    LOCAL   nCharCount  :DWORD

    .if uMsg == WM_INITDIALOG
      invoke  SetWindowText, hWnd, ADDR DlgTitleText
      invoke  LoadIcon, hInstance, IDI_ICON1
      invoke  SendMessage, hWnd, WM_SETICON, ICON_BIG, eax
      invoke  GetDlgItem, hWnd, IDC_EDTSERVER
      invoke  SendMessage, eax, EM_LIMITTEXT, MAX_SERVERNAME, 0
      invoke  GetDlgItem, hWnd, IDC_EDTPORT
      invoke  SendMessage, eax, EM_LIMITTEXT, MAX_PORT, 0
      invoke  GetDlgItem, hWnd, IDC_EDTNAME
      invoke  SendMessage, eax, EM_LIMITTEXT, MAX_DISPLAYNAME, 0
      invoke  GetDlgItem, hWnd, IDC_EDTFROM
      invoke  SendMessage, eax, EM_LIMITTEXT, MAX_FROMADDRESS, 0
      invoke  GetDlgItem, hWnd, IDC_EDTTO
      invoke  SendMessage, eax, EM_LIMITTEXT, MAX_TOADDRESS, 0
      invoke  GetDlgItem, hWnd, IDC_EDTSUBJECT
      invoke  SendMessage, eax, EM_LIMITTEXT, MAX_SUBJECT, 0
      invoke  GetDlgItem, hWnd, IDC_EDTMESSAGE
      invoke  SendMessage, eax, EM_LIMITTEXT, MAX_MESSAGE, 0
      invoke  SetDlgItemText, hWnd, IDC_EDTSERVER, ADDR SMTPServerName
      invoke  SetDlgItemText, hWnd, IDC_EDTPORT, ADDR SMTPServerPort
      invoke  SetDlgItemText, hWnd, IDC_EDTNAME, ADDR FriendlyName
      invoke  SetDlgItemText, hWnd, IDC_EDTFROM, ADDR FromAddress
      invoke  CreatePopupMenu
      mov     hPopupMenu, eax
      invoke  AppendMenu, hPopupMenu, MF_STRING, IDM_RESTORE, CTEXT("&Restore")
      invoke  AppendMenu, hPopupMenu, MF_STRING, IDM_QUIT, CTEXT("&Quit")
      mov     TrayIcon.cbSize, sizeof NOTIFYICONDATA
      push    hWnd
      pop     TrayIcon.hwnd
      mov     TrayIcon.uID, IDI_TRAY
      mov     TrayIcon.uCallbackMessage, WM_SHELLNOTIFY
      mov     TrayIcon.uFlags, NIF_ICON + NIF_TIP + NIF_MESSAGE
      invoke  LoadIcon, hInstance, IDI_ICON1
      mov     TrayIcon.hIcon, eax
      invoke  lstrcpy, ADDR TrayIcon.szTip, ADDR DlgTitleText
      invoke  Shell_NotifyIcon, NIM_ADD, ADDR TrayIcon
      invoke  CreateSolidBrush, 0e0e0e0h
      mov     EditBackgroundBrush, eax
    .elseif uMsg == WM_LBUTTONDOWN
      invoke  SendMessage, hWnd, WM_NCLBUTTONDOWN, HTCAPTION, NULL
    .elseif uMsg == WM_CTLCOLOREDIT
      invoke  GetDlgItem, hWnd, IDC_EDTMESSAGE
      .if lParam == eax
        invoke  SetBkColor, wParam, 0e0e0e0h
        mov     eax, EditBackgroundBrush
      .else
        mov     eax, FALSE
      .endif
      ret
    .elseif uMsg == WM_COMMAND
      mov     eax, wParam
      shr     eax, 16
      .if wParam == IDC_BTNSEND
        invoke  SendMail, hWnd
      .elseif wParam == IDC_BTNCLEAR
        invoke  SetDlgItemText, hWnd, IDC_EDTTO, 0
        invoke  SetDlgItemText, hWnd, IDC_EDTSUBJECT, 0
        invoke  SetDlgItemText, hWnd, IDC_EDTMESSAGE, 0
        invoke  SetDlgItemInt, hWnd, IDC_CHARS, 0, FALSE
      .elseif wParam ==IDC_BTNHIDE
        invoke  ShowWindow, hWnd, SW_HIDE
      .elseif wParam == IDCANCEL
        invoke  EndDialog, hWnd, NULL
        invoke  DestroyMenu, hPopupMenu
        invoke  Shell_NotifyIcon, NIM_DELETE, ADDR TrayIcon
        invoke  DeleteObject, EditBackgroundBrush
        .if sock != 0
          invoke  closesocket, sock
        .endif
        invoke  WSACleanup
      .elseif wParam == IDM_QUIT
        invoke  PostMessage, hWnd, WM_COMMAND, IDCANCEL, 0
      .elseif wParam == IDM_RESTORE
        invoke  ShowWindow, hWnd, SW_RESTORE
      .elseif eax == EN_CHANGE
        mov     eax, wParam
        .if ax == IDC_EDTMESSAGE
          invoke  GetDlgItemText, hWnd, IDC_EDTMESSAGE, ADDR MailMessage, MAX_MESSAGE
          invoke  lstrlen, ADDR MailMessage
          invoke  SetDlgItemInt, hWnd, IDC_CHARS, eax, FALSE
        .endif
      .endif
    .elseif uMsg == WM_SOCKET
      mov     eax, lParam
      .if ax==FD_CONNECT
        shr     eax, 16
        .if ax==NULL
          invoke  MessageBox, hWnd, CTEXT("Connected"), ADDR DlgTitleText, MB_OK
        .else
          invoke  MessageBox, hWnd, CTEXT("Remote computer is not responding."), ADDR DlgTitleText, MB_OK
        .endif
      .elseif ax==FD_READ
        shr     eax, 16
        .if ax==NULL
          invoke  RReadSocket, hWnd
        .else
          invoke  MessageBox, hWnd, CTEXT("Error: FD_READ"), ADDR DlgTitleText, MB_OK
        .endif
      .elseif ax==FD_CLOSE
        shr     eax, 16
        .if ax == NULL
          invoke  closesocket, sock
          mov     sock, 0
          invoke  MessageBox, hWnd, CTEXT("Mail Sent and Disconnected from Server!"), ADDR DlgTitleText, MB_OK
          mov     State, 0
        .endif
      .endif
    .elseif uMsg == WM_SHELLNOTIFY
      .if wParam == IDI_TRAY
        .if lParam == WM_RBUTTONDOWN
          invoke  GetCursorPos, addr pt
          invoke  SetForegroundWindow, hWnd
          invoke  TrackPopupMenu, hPopupMenu, TPM_RIGHTALIGN, pt.x, pt.y, NULL, hWnd, NULL
          invoke  PostMessage, hWnd, WM_NULL, 0, 0
        .elseif lParam == WM_LBUTTONDBLCLK
          invoke  SendMessage, hWnd, WM_COMMAND, IDM_RESTORE, 0
        .endif
      .endif
    .else
      mov     eax, FALSE
      ret
    .endif
    mov     eax, TRUE
    ret
;====================
DlgProc endp

;====================;
; Get settings from SendMail.ini        ;
;====================;
GetSettingsFromIni proc uses ebx esi edi
;====================
    LOCAL   bRetVal     :DWORD
    LOCAL   Dummy[1024] :BYTE

    invoke  AppPath, ADDR Dummy
    invoke  BuildString, ADDR Dummy, ADDR szIniFileName
    invoke  GetPrivateProfileString, ADDR szIniSectionName, CTEXT("SMTPServer"), CTEXT("Err"), ADDR SMTPServerName, MAX_SERVERNAME, ADDR Dummy
    invoke  lstrcmp, CTEXT("Err"), ADDR SMTPServerName
    .if eax == 0
      lea     eax, SMTPServerName
      mov     BYTE PTR [eax], 0
    .endif
    invoke  GetPrivateProfileString, ADDR szIniSectionName, CTEXT("SMTPServerPort"), CTEXT("Err"), ADDR SMTPServerPort, MAX_PORT, ADDR Dummy
    invoke  lstrcmp, CTEXT("Err"), ADDR SMTPServerPort
    .if eax == 0
      lea     eax, SMTPServerPort
      mov     BYTE PTR [eax], 0
    .endif
    invoke  GetPrivateProfileString, ADDR szIniSectionName, CTEXT("DisplayName"), CTEXT("Err"), ADDR FriendlyName, MAX_DISPLAYNAME, ADDR Dummy
    invoke  lstrcmp, CTEXT("Err"), ADDR FriendlyName
    .if eax == 0
      lea     eax, FriendlyName
      mov     BYTE PTR [eax], 0
    .endif
    invoke  GetPrivateProfileString, ADDR szIniSectionName, CTEXT("FromAddress"), CTEXT("Err"), ADDR FromAddress, MAX_FROMADDRESS, ADDR Dummy
    invoke  lstrcmp, CTEXT("Err"), ADDR FromAddress
    .if eax == 0
      lea     eax, FromAddress
      mov     BYTE PTR [eax], 0
    .endif
    mov     bRetVal, 0
    mov     eax, bRetVal
    ret
;====================
GetSettingsFromIni endp

SendMail proc USES ebx esi edi hWnd :DWORD
;====================
    LOCAL bState:DWORD
    LOCAL Dummy :DWORD

    invoke  GlobalAlloc, GPTR, MAX_MESSAGE+1000
    mov     Dummy, eax
    invoke  GetDlgItemText, hWnd, IDC_EDTSERVER, Dummy, MAX_SERVERNAME
    invoke  lstrcpy, ADDR SMTPServerName, Dummy
    invoke  GetDlgItemInt, hWnd, IDC_EDTPORT, ADDR bState, FALSE
    mov     nSMTPServerPort, eax
    invoke  GetDlgItemText, hWnd, IDC_EDTNAME, ADDR FriendlyName, MAX_DISPLAYNAME
    invoke  GetDlgItemText, hWnd, IDC_EDTFROM, ADDR FromAddress, MAX_FROMADDRESS
    invoke  GetDlgItemText, hWnd, IDC_EDTTO, ADDR ToAddress, MAX_TOADDRESS
    invoke  GetDlgItemText, hWnd, IDC_EDTSUBJECT, ADDR MailSubject, MAX_SUBJECT
    invoke  lstrcpy, ADDR MailMessage, CTEXT("From: ")
    invoke  lstrcat, ADDR MailMessage, ADDR FriendlyName
    invoke  lstrcat, ADDR MailMessage, CTEXT(" <")
    invoke  lstrcat, ADDR MailMessage, ADDR FromAddress
    invoke  lstrcat, ADDR MailMessage, CTEXT(">", 13, 10)
    invoke  lstrcat, ADDR MailMessage, CTEXT("Subject: ")
    invoke  lstrcat, ADDR MailMessage, ADDR MailSubject
    invoke  lstrcat, ADDR MailMessage, CTEXT(13, 10)
    invoke  lstrcat, ADDR MailMessage, CTEXT("To: ")
    invoke  lstrcat, ADDR MailMessage, ADDR ToAddress
    invoke  lstrcat, ADDR MailMessage, CTEXT(13, 10, 13, 10)
    invoke  GetDlgItemText, hWnd, IDC_EDTMESSAGE, Dummy, MAX_MESSAGE
    invoke  lstrcat, ADDR MailMessage, Dummy
    invoke  lstrcat, ADDR MailMessage, CTEXT(13, 10, ".", 13, 10)
    invoke  RConnect, hWnd
    invoke  GlobalFree, Dummy
    ret
;====================
SendMail endp

ReplyMessage proc Message :DWORD
;====================
;   invoke  MessageBox, NULL, Message, NULL, MB_OK
    invoke  GetLength, Message
    invoke  send, sock, Message, eax, 0
    ret
;====================
ReplyMessage endp

RReadSocket proc hWnd:HWND
;====================
    invoke  ioctlsocket, sock, FIONREAD, ADDR available_data
    .if eax == NULL
      mov     eax, available_data
      add     eax, 2
      mov     available_data, eax
      invoke  GlobalAlloc, GHND, available_data
      mov     hMemory, eax
      invoke  GlobalLock, eax
      mov     buffer, eax
      invoke  recv, sock, buffer, available_data, 0
      mov     actual_data_read, eax
      invoke  ProcessCommand, hWnd, buffer
      invoke  GlobalUnlock, buffer
      invoke  GlobalFree, hMemory
    .endif
    ret
;====================
RReadSocket endp

ProcessCommand proc hWnd :DWORD, Command :DWORD
;====================
    LOCAL   Dummy[1024] :BYTE
    LOCAL   CompName[MAX_COMPUTERNAME_LENGTH+1] :BYTE
    LOCAL   CurPos      :DWORD
    LOCAL   StatusCode  :DWORD
    LOCAL   nSize       :DWORD

    xor     eax, eax
    mov     CurPos, 0
    .while eax != -1
      mov     edx, Command
      add     edx, CurPos
      push    edx
      invoke  InStringx, edx, CTEXT(13, 10)
      .if eax != -1
        add     eax, 2
        mov     CurPos, eax
        pop     edx
        invoke  lstrcpyn, ADDR Dummy, edx, CurPos
        lea     eax, Dummy
        add     eax, CurPos
        mov     BYTE PTR [eax], 0
        lea     eax, Dummy
        mov     BYTE PTR [eax] + 3, 0
        invoke  Convert, ADDR Dummy
        mov     StatusCode, eax
        .if StatusCode == 220
          mov     nSize, sizeof CompName
          invoke  GetComputerName, ADDR CompName, ADDR nSize
          invoke  lstrcpy, ADDR Dummy, CTEXT("helo ")
          invoke  lstrcat, ADDR Dummy, ADDR CompName
          invoke  lstrcat, ADDR Dummy, CTEXT(13, 10)
          invoke  ReplyMessage, ADDR Dummy
          mov     State, 1
        .elseif StatusCode == 221
        .elseif StatusCode == 250
          .if State == 1
            invoke  lstrcpy, ADDR Dummy, CTEXT("mail from: <")
            invoke  lstrcat, ADDR Dummy, ADDR FromAddress
            invoke  lstrcat, ADDR Dummy, CTEXT(">", 13, 10)
            invoke  ReplyMessage, ADDR Dummy
            mov     State, 2
          .elseif State == 2
            invoke  lstrcpy, ADDR Dummy, CTEXT("rcpt to: <")
            invoke  lstrcat, ADDR Dummy, ADDR ToAddress
            invoke  lstrcat, ADDR Dummy, CTEXT(">", 13, 10)
            invoke  ReplyMessage, ADDR Dummy
            mov     State, 3
          .elseif State == 3
            invoke  ReplyMessage, CTEXT("Data",13, 10)
            mov     State, 4
          .elseif State == 5
            invoke  MessageBox, hWnd, CTEXT("Mail Sent!"), ADDR DlgTitleText, MB_OK
            invoke  ReplyMessage, CTEXT("Quit",13, 10)
            mov     State, -1
          .endif
        .elseif StatusCode == 354
          invoke  ReplyMessage, ADDR MailMessage
          mov     State, 5
        .else
          invoke  MessageBox, hWnd, Command, ADDR DlgTitleText, MB_OK
          invoke  SendMessage, hWnd, WM_SOCKET, 0, FD_CLOSE
        .endif
        xor     eax, eax
      .endif
    .endw
    ret
;====================
ProcessCommand endp

RConnect proc hWnd:HWND
;====================
    invoke  WSAStartup, 101h, ADDR wsadata
    .if eax != NULL
      invoke  MessageBox, hWnd, CTEXT("Can't initialize Windows Sockets."), ADDR DlgTitleText, MB_OK
      jmp     ExitProc
    .endif
    invoke  socket, AF_INET, SOCK_STREAM, 0
    .if eax != INVALID_SOCKET
      mov     sock, eax
    .else
      invoke  WSAHandleError
      jmp     ExitProc
    .endif
    invoke  WSAAsyncSelect, sock, hWnd, WM_SOCKET, FD_CONNECT+FD_READ+FD_CLOSE
    .if eax == SOCKET_ERROR
      invoke  WSAHandleError
      jmp     ExitProc
    .endif
    mov     sin.sin_family, AF_INET
    invoke  htons, nSMTPServerPort
    mov     sin.sin_port, ax
    invoke  gethostbyname, ADDR SMTPServerName
    .if eax == NULL
      invoke  WSAHandleError
      jmp     ExitProc
    .endif
    mov     eax, [eax+12]
    mov     eax, [eax]
    mov     eax, [eax]
    mov     sin.sin_addr, eax
    invoke  connect, sock, ADDR sin, sizeof sin
    .if eax == SOCKET_ERROR
      invoke  WSAGetLastError
      .if eax != WSAEWOULDBLOCK
        invoke  MessageBox, hWnd, CTEXT("Error: Connect"), ADDR DlgTitleText, MB_OK
      .endif
    .endif
ExitProc:
    ret
;====================
RConnect endp

InStringx proc uses ebx edi esi StrMain:DWORD, StrSub:DWORD
;====================
    invoke  StrLen, StrMain
    mov     ecx, eax
    push    ecx
    invoke  StrLen, StrSub
    pop     ecx
    mov     ebx,eax
    .if ecx < eax
      mov     eax, -1
    .elseif ecx == eax
      mov     esi, StrMain
      mov     edi, StrSub
      repe cmpsb
      je      Equal
      mov     eax, -1
      jmp     GetOut
Equal:
      xor     eax, eax
GetOut:
    .else
      sub     ecx, eax
      inc     ecx
      mov     eax, ecx
      xor     edx, edx
      push    eax
      .while eax != 0
        mov     edi, StrMain
        add     edi, edx
        mov     esi, StrSub
        mov     ecx, ebx
        repe    cmpsb
        je      Found
        jmp     DontFind
Found:
        .break
DontFind:
        inc     edx
        dec     eax
      .endw
      pop     ecx
      .if eax != 0
        sub     ecx, eax
        mov     eax, ecx
      .else
        mov     eax, -1
      .endif
    .endif
    ret
;====================
InStringx endp

HandleError proc
;====================
    LOCAL   lpMsgBuffer :LPVOID

    mov     cx, SUBLANG_DEFAULT
    shl     ecx, 10
    push    NULL
    push    0
    lea     eax, lpMsgBuffer
    push    eax
    push    ecx
    invoke  GetLastError
    push    eax
    push    NULL
    mov     edx, FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM
    push    edx
    call    FormatMessage
    invoke  MessageBox, NULL, lpMsgBuffer, ADDR DlgTitleText, MB_OK
    invoke  LocalFree, lpMsgBuffer
    ret
;====================
HandleError endp

WSAHandleError proc
;====================
    LOCAL   lpMsgBuffer :LPVOID

    mov     cx, SUBLANG_DEFAULT
    shl     ecx, 10
    push    NULL
    push    0
    lea     eax, lpMsgBuffer
    push    eax
    push    ecx
    invoke  WSAGetLastError
    push    eax
    push    NULL
    mov     edx, FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM
    push    edx
    call    FormatMessage
    invoke  MessageBox, NULL, lpMsgBuffer, ADDR DlgTitleText, MB_OK
    invoke  LocalFree, lpMsgBuffer
    ret
;====================
WSAHandleError endp

AppPath proc lpPathBuffer:DWORD
;====================
    invoke  GetModuleFileName,0,lpPathBuffer,128  ; return length in eax
    add     eax, lpPathBuffer
@@:
    dec     eax                         ; dec ECX
    cmp     BYTE PTR [eax],'\'          ; compare if "\"
    jne     @B                          ; jump back to @@: if not "\"
    mov     BYTE PTR [eax+1],0          ; write zero terminator after "\"
    mov     eax, lpPathBuffer
    ret
;====================
AppPath endp

BuildString proc lpszSource:DWORD, lpszAdd:DWORD
;====================
    push     edi
    invoke  GetLength,lpszSource        ; get source length
    mov     edi, lpszSource
    mov     ecx, lpszAdd
    add     edi, eax                    ; set write starting position
    xor     edx, edx                    ; zero index
    xor     eax, eax
@@:
    mov     al, [ecx+edx]               ; Append string to end of source
    mov     [edi+edx], al
    add     edx, 1
    test    al, al                      ; exit when terminator is written
    jne     @B
    pop     edi
    mov     eax, lpszSource             ; return start address of source
    ret
;====================
BuildString endp

GetLength proc src:DWORD
;====================
    mov     eax, src
    sub     eax, 4
@@:
    add     eax, 4
    cmp     BYTE PTR [eax], 0
    je      lb1
    cmp     BYTE PTR [eax+1], 0
    je      lb2
    cmp     BYTE PTR [eax+2], 0
    je      lb3
    cmp     BYTE PTR [eax+3], 0
    jne     @B
    sub     eax, [src]
    add     eax, 3
    ret     4
lb3:
    sub     eax, [src]
    add     eax, 2
    ret
lb2:
    sub     eax, [src]
    add     eax, 1
    ret
lb1:
    sub     eax, [src]
    ret
;====================
GetLength endp

Convert proc String:DWORD
;====================;
; Convert decimal string into dword     ;
; value return value in eax             ;
;====================;
    xor     eax, eax
    mov     esi, [String]
    xor     ecx, ecx
    xor     edx, edx
    mov     al, [esi]
    inc     esi
    cmp     al, 2D
    jne     proceed
    mov     al, byte ptr [esi]
    not     edx
    inc     esi
    jmp     proceed
@@: 
    sub     al, 30h
    lea     ecx, dword ptr [ecx+4*ecx]
    lea     ecx, dword ptr [eax+2*ecx]
    mov     al, byte ptr [esi]
    inc     esi
proceed:
    or      al, al
    jne     @B
    lea     eax, dword ptr [edx+ecx]
    xor     eax, edx
    ret
;====================
Convert endp

    end     Start

